Attribute VB_Name = "mdlGraphics"
'Some functions for work with bitmaps\Images
Option Explicit

Public Declare Function SetPixel Lib "gdi32" (ByVal hdc As Long, ByVal X As Long, ByVal Y As Long, ByVal crColor As Long) As Long
Public Declare Function StretchBlt Lib "gdi32" (ByVal hdc As Long, ByVal X As Long, ByVal Y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal hSrcDC As Long, ByVal xSrc As Long, ByVal ySrc As Long, ByVal nSrcWidth As Long, ByVal nSrcHeight As Long, ByVal dwRop As Long) As Long
Public Declare Function TransparentBlt Lib "msimg32.dll" (ByVal hdc As Long, ByVal X As Long, ByVal Y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal hSrcDC As Long, ByVal xSrc As Long, ByVal ySrc As Long, ByVal nSrcWidth As Long, ByVal nSrcHeight As Long, ByVal crTransparent As Long) As Boolean
Public Declare Function GetKeyState Lib "user32" (ByVal nVirtKey As Long) As Integer
Public Declare Function GetPixel Lib "gdi32" (ByVal hdc As Long, ByVal X As Long, ByVal Y As Long) As Long
Public Declare Function BitBlt Lib "gdi32" (ByVal hDestDC As Long, ByVal X As Long, ByVal Y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal hSrcDC As Long, ByVal xSrc As Long, ByVal ySrc As Long, ByVal dwRop As Long) As Long
Public Declare Function AlphaBlend Lib "msimg32" (ByVal hDestDC As Long, ByVal X As Long, ByVal Y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal hSrcDC As Long, ByVal xSrc As Long, ByVal ySrc As Long, ByVal widthSrc As Long, ByVal heightSrc As Long, ByVal blendFunct As Long) As Boolean
Private Declare Function CreateCompatibleBitmap Lib "gdi32" (ByVal hdc As Long, ByVal nWidth As Long, ByVal nHeight As Long) As Long
Private Declare Function CreateCompatibleDC Lib "gdi32" (ByVal hdc As Long) As Long
Private Declare Function SelectObject Lib "gdi32" (ByVal hdc As Long, ByVal hObject As Long) As Long
Private Declare Function DeleteDC Lib "gdi32" (ByVal hdc As Long) As Long
Public Declare Function DeleteObject Lib "gdi32" (ByVal hObject As Long) As Long
Public Declare Sub CopyMemory Lib "KERNEL32" Alias "RtlMoveMemory" (pDst As Any, pSrc As Any, ByVal ByteLen As Long)

Private Type BITMAPINFOHEADER
  biSize          As Long
  biWidth         As Long
  biHeight        As Long
  biPlanes        As Integer
  biBitCount      As Integer
  biCompression   As Long
  biSizeImage     As Long
  biXPelsPerMeter As Long
  biYPelsPerMeter As Long
  biClrUsed       As Long
  biClrImportant  As Long
End Type


Private Declare Function GetDIBits Lib "gdi32" (ByVal aHDC As Long, ByVal hBitmap As Long, ByVal nStartScan As Long, _
ByVal nNumScans As Long, lpBits As Any, lpBI As BITMAPINFOHEADER, ByVal wUsage As Long) As Long
Private Declare Function SetDIBits Lib "gdi32" (ByVal hdc As Long, ByVal hBitmap As Long, ByVal nStartScan As Long, _
ByVal nNumScans As Long, lpBits As Any, lpBI As BITMAPINFOHEADER, ByVal wUsage As Long) As Long

Dim bih As BITMAPINFOHEADER
Dim bmpBits() As Long

Private Const DIB_RGB_COLORS As Long = 0
Public Const SRCCOPY = &HCC0020

Private Type Color
    Red As Long
    Green As Long
    Blue As Long
End Type

'Public blnOldColor As Boolean
Dim hbmp As Long

Public Function CreateDIB(ByVal lDC As Long, ByVal lHandle As OLE_HANDLE, ByVal lWidth As Long, ByVal lHeight As Long) As Boolean
  bih.biSize = Len(bih)
  bih.biPlanes = 1
  bih.biHeight = lHeight
  bih.biWidth = lWidth
  bih.biBitCount = 32
  
  ReDim bmpBits((lHeight * lWidth) - 1)
  CreateDIB = GetDIBits(lDC, lHandle, 0&, lHeight, bmpBits(0), bih, DIB_RGB_COLORS)
End Function

'Rotate an image
Public Sub RotateImage(picDestiny As PictureBox, picSource As PictureBox, ByVal Angle As Single, Optional ByVal PosX As Long = 0, Optional ByVal PosY As Long = 0)
    Dim X1 As Long, Y1 As Long
    Dim X2 As Long, Y2 As Long
    Dim X As Long, Y As Long
    Dim CosA As Single, SinA As Single
    Dim Wdth As Long, Hght As Long
    Dim SrcOffX As Long, SrcOffY As Long
    Dim SrcHdc As Long, TgtHdc As Long
   
    picDestiny.Cls
    'calculate negative angle in radians, negative because mapping from destination to source
    Angle = Angle * 1.74532925199433E-02 'same as Angle * (pi/180) * -1
   
    CosA = Cos(Angle)
    SinA = Sin(Angle)
    Set picDestiny.Picture = Nothing
    picDestiny.Cls
    If picSource.Height > picSource.Width Then
        picSource.Width = picSource.Height
    Else
        picSource.Height = picSource.Width
    End If
    With picSource 'Get the width and height in pixels
        Wdth = .ScaleX(.ScaleWidth, .ScaleMode, vbPixels)
        Hght = .ScaleY(.ScaleHeight, .ScaleMode, vbPixels)
        'Make the target picturebox the same size as the source
        picDestiny.ScaleMode = .ScaleMode
        picDestiny.BorderStyle = .BorderStyle
        picDestiny.Width = .Width
        picDestiny.Height = .Height
    End With
   
    SrcOffX = (Wdth \ 2)
    SrcOffY = (Hght \ 2)
   
    SrcHdc = picSource.hdc
    TgtHdc = picDestiny.hdc
   
    For Y2 = 0 To Hght
        For X2 = 0 To Wdth
            X = X2 - SrcOffX
            Y = Y2 - SrcOffY
            X1 = (X * CosA - Y * SinA) + SrcOffX
            If X1 >= 0 Then
                If X1 < Wdth Then 'the pixel is within the horizontal range
                    Y1 = (X * SinA + Y * CosA) + SrcOffY
                    If Y1 >= 0 Then
                        If Y1 < Hght Then 'the pixel is within range
                            SetPixel TgtHdc, X2 + PosX, Y2 + PosY, GetPixel(SrcHdc, X1, Y1)
                        End If
                    End If
                End If
            End If
        Next X2
    Next Y2
    picDestiny.Picture = picDestiny.Image
End Sub

Public Sub ChangeColor(Picture As Object, OldColor As Long, NewColor As Long)
    Dim mDC As Long
    Dim mBMP As Long
    Dim PosX As Long
    Dim PosY As Long
    Dim PixelColor As Long
    Dim ScaleMode As Integer
    Dim AutoRedraw As Boolean
    
    ScaleMode = Picture.ScaleMode
    Picture.ScaleMode = 3
    AutoRedraw = Picture.AutoRedraw
    Picture.AutoRedraw = True
    mDC = CreateCompatibleDC(Picture.hdc)
    mBMP = CreateCompatibleBitmap(Picture.hdc, Picture.ScaleWidth, Picture.ScaleHeight)
    SelectObject mDC, mBMP
    BitBlt mDC, 0, 0, Picture.ScaleWidth, Picture.ScaleHeight, Picture.hdc, 0, 0, vbSrcCopy
    For PosX = 0 To Picture.ScaleWidth
        For PosY = 0 To Picture.ScaleHeight
            PixelColor = GetPixel(mDC, PosX, PosY)
            If PixelColor <> -1 Then
                If PixelColor = OldColor Then
                    SetPixel mDC, PosX, PosY, NewColor
                End If
            End If
        Next PosY
    Next PosX
    BitBlt Picture.hdc, 0, 0, Picture.ScaleWidth, Picture.ScaleHeight, mDC, 0, 0, vbSrcCopy
    Picture.ScaleMode = ScaleMode
    Picture.Picture = Picture.Image
    Picture.AutoRedraw = AutoRedraw
    DeleteObject mBMP
    DeleteDC mDC
End Sub

Public Function RGBValues(Color As Long) As Color 'find the rgb color values of a color
    Dim ReturnColor As Color
    With ReturnColor
        .Red = Fix(Color And 255)
        .Green = Fix((Color And 65535) / 256)
        .Blue = Fix(Color / 65536)
    End With
    RGBValues = ReturnColor
End Function

Public Sub GrayScale32(ByVal lDC As Long, ByVal lHandle As OLE_HANDLE, ByVal lWidth As Long, ByVal lHeight As Long)
    Dim X As Long
  
    If CreateDIB(lDC, lHandle, lWidth, lHeight) Then
        For X = 0 To (lWidth * lHeight) - 1
            bmpBits(X) = ((77& * (bmpBits(X) And &HFF&) + _
                 152& * (bmpBits(X) And &HFF00&) \ &H100& + _
                  28& * (bmpBits(X) \ &H10000)) \ 256&) * &H10101
        Next X
    
        SetDIBits lDC, lHandle, 0, lHeight, bmpBits(0), bih, DIB_RGB_COLORS
        DeleteObject hbmp
    End If
End Sub

Public Function IsPicture(Picture As Object) As Boolean
    Dim mDC As Long
    Dim mBMP As Long
    Dim PosX As Long
    Dim PosY As Long
    Dim FirstPixelColor As Long
    Dim PixelColor As Long
    Dim ScaleMode As Integer
    Dim AutoRedraw As Boolean
    
    ScaleMode = Picture.ScaleMode
    Picture.ScaleMode = 3
    AutoRedraw = Picture.AutoRedraw
    Picture.AutoRedraw = True
    mDC = CreateCompatibleDC(Picture.hdc)
    mBMP = CreateCompatibleBitmap(Picture.hdc, Picture.ScaleWidth, Picture.ScaleHeight)
    SelectObject mDC, mBMP
    BitBlt mDC, 0, 0, Picture.ScaleWidth, Picture.ScaleHeight, Picture.hdc, 0, 0, vbSrcCopy
    FirstPixelColor = GetPixel(mDC, 0, 0)
    For PosX = 0 To Picture.ScaleWidth
        For PosY = 0 To Picture.ScaleHeight
            PixelColor = GetPixel(mDC, PosX, PosY)
            If PixelColor <> -1 Then
                If PixelColor = FirstPixelColor Then
                    IsPicture = False
                Else
                    IsPicture = True
                    Picture.ScaleMode = ScaleMode
                    Picture.Picture = Picture.Image
                    Picture.AutoRedraw = AutoRedraw
                    DeleteObject mBMP
                    DeleteDC mDC
                    Exit Function
                End If
            End If
        Next PosY
    Next PosX
    Picture.ScaleMode = ScaleMode
    Picture.Picture = Picture.Image
    Picture.AutoRedraw = AutoRedraw
    DeleteObject mBMP
    DeleteDC mDC
End Function

