Attribute VB_Name = "mdlMouseWheel"
' ///////////////////////////////////////////////
'  Return MouseWheel Over Multiple UserControls
'  Ed Wilk/Edgemeal
'  Example UPDATED September 18, 2008
' ///////////////////////////////////////////////
'
' ****************************************************
' IMPORTANT NOTICE:
'   To stop the hook from sending messages to a
'   window handle set the variable MouseOverControl
'   to zero!
' ****************************************************
Option Explicit
Private PrevWin2 As Long
Private Declare Function SendMessage Lib "user32" Alias "SendMessageA" (ByVal hWnd As Long, ByVal wMsg As Long, ByVal wParam As Long, lParam As Any) As Long
Private Declare Function SetWindowLong Lib "user32" Alias "SetWindowLongA" (ByVal hWnd As Long, ByVal nIndex As Long, ByVal dwNewLong As Long) As Long
Private Declare Function CallWindowProc Lib "user32" Alias "CallWindowProcA" (ByVal lpPrevWndFunc As Long, ByVal hWnd As Long, ByVal Msg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
Private Const GWL_WNDPROC = (-4)
Private Const WM_MOUSEWHEEL = &H20A
Public MouseOverControl As Long ' Handle for User Control (mouse move)
Private Const WM_KEYDOWN = &H100

Private Function Proc2(ByVal hWnd As Long, ByVal Msg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
    
    ' Pass mouse wheel as arrow keys to a window handle(user controls).
    
    If Msg = WM_MOUSEWHEEL Then  ' the mouse wheel rotated
        
        If MouseOverControl > 0 Then
            If wParam / 65536 > 0 Then
                SendMessage MouseOverControl, WM_KEYDOWN, 1000, 0
            Else
                SendMessage MouseOverControl, WM_KEYDOWN, 1001, 0
            End If
        End If
        
    End If
        
    Proc2 = CallWindowProc(PrevWin2, hWnd, Msg, wParam, lParam)
    
End Function

Public Sub Hook2(handle As Long)
    If PrevWin2 = 0 Then
        PrevWin2 = SetWindowLong(handle, GWL_WNDPROC, AddressOf Proc2)
    End If
End Sub

Public Sub Unhook2(handle As Long)
    If PrevWin2 Then
        Call SetWindowLong(handle, GWL_WNDPROC, PrevWin2)
        PrevWin2 = 0
    End If
End Sub
